# Base Rest Datamodel

This addon allows you to use Pydantic objects as params and/or response with your REST API methods.

Table of contents

- Usage
- Bug Tracker
- Credits
  - Authors
  - Contributors
  - Maintainers

# Usage

To use Pydantic instances as request and/or response of a REST service endpoint you must:

- Define your Pydantic classes;
- Provides the information required to the `odoo.addons.base_rest.restapi.method` decorator;

    from odoo.addons.base_rest import restapi
    from odoo.addons.component.core import Component
    from odoo.addons.pydantic.models import BaseModel

    class PingMessage(BaseModel):
        message: str

    class PingService(Component):
        _inherit = 'base.rest.service'
        _name = 'ping.service'
        _usage = 'ping'
        _collection = 'my_module.services'

        @restapi.method(
            [(["/pong"], "GET")],
            input_param=restapi.PydanticModel(PingMessage),
            output_param=restapi.PydanticModel(PingMessage),
            auth="public",
        )
        def pong(self, ping_message):
            return PingMessage(message = "Received: " + ping_message.message)

# Bug Tracker

Bugs are tracked on GitHub Issues. In case of trouble, please check there if your issue has already been reported. If you spotted it first, help us to smash it by providing a detailed and welcomed feedback.

Do not contact contributors directly about support or help with technical issues.

# Credits

## Authors

- ACSONE SA/NV

## Contributors

- Laurent Mignon <laurent.mignon@acsone.eu>

## Maintainers

This module is maintained by the OCA.

OCA, or the Odoo Community Association, is a nonprofit organization whose mission is to support the collaborative development of Odoo features and promote its widespread use.

This module is part of the OCA/rest-framework project on GitHub.

You are welcome to contribute. To learn how please visit https://odoo-community.org/page/Contribute.